/**
  ******************************************************************************
  * @file    stm32f4xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  *
  * COPYRIGHT(c) 2018 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "stm32f4xx_hal.h"
#include "stm32f4xx.h"
#include "stm32f4xx_it.h"
#include "main.h"
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
//
/******************************************************************************/
/*            Cortex-M4 Processor Interruption and Exception Handlers         */ 
/******************************************************************************/
static int val = 0;
extern DAC_HandleTypeDef hdac;
//
extern ADC_HandleTypeDef hadc1;
//**************************************************
//
extern int_fast16_t sin_lo_buf[1024*8];
extern int_fast16_t cos_lo_buf[1024*8];
uint_fast16_t mix_i=0;
uint_fast16_t filt_i=0;
//
int_fast32_t sin_lo_mix_buf[12];
int_fast32_t cos_lo_mix_buf[12];
//
int_fast32_t sin_lo_mix_LPF_buf[3];
int_fast32_t cos_lo_mix_LPF_buf[3];
int_fast16_t my_data ;
//
int_fast32_t sin_lo_mix_LPF_2_buf[2];
int_fast32_t cos_lo_mix_LPF_2_buf[2];
//
int_fast32_t sin_lo_mix_LPF_diff=0;
int_fast32_t cos_lo_mix_LPF_diff=0;


//***************************************************
/**
* @brief This function handles Non maskable interrupt.
*/
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */

  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
* @brief This function handles Hard fault interrupt.
*/
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */

  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
  /* USER CODE BEGIN HardFault_IRQn 1 */

  /* USER CODE END HardFault_IRQn 1 */
}

/**
* @brief This function handles Memory management fault.
*/
void MemManage_Handler(void)
{
  /* USER CODE BEGIN MemoryManagement_IRQn 0 */

  /* USER CODE END MemoryManagement_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_MemoryManagement_IRQn 0 */
    /* USER CODE END W1_MemoryManagement_IRQn 0 */
  }
  /* USER CODE BEGIN MemoryManagement_IRQn 1 */

  /* USER CODE END MemoryManagement_IRQn 1 */
}

/**
* @brief This function handles Pre-fetch fault, memory access fault.
*/
void BusFault_Handler(void)
{
  /* USER CODE BEGIN BusFault_IRQn 0 */

  /* USER CODE END BusFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_BusFault_IRQn 0 */
    /* USER CODE END W1_BusFault_IRQn 0 */
  }
  /* USER CODE BEGIN BusFault_IRQn 1 */

  /* USER CODE END BusFault_IRQn 1 */
}

/**
* @brief This function handles Undefined instruction or illegal state.
*/
void UsageFault_Handler(void)
{
  /* USER CODE BEGIN UsageFault_IRQn 0 */

  /* USER CODE END UsageFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_UsageFault_IRQn 0 */
    /* USER CODE END W1_UsageFault_IRQn 0 */
  }
  /* USER CODE BEGIN UsageFault_IRQn 1 */

  /* USER CODE END UsageFault_IRQn 1 */
}

/**
* @brief This function handles System service call via SWI instruction.
*/
void SVC_Handler(void)
{
  /* USER CODE BEGIN SVCall_IRQn 0 */

  /* USER CODE END SVCall_IRQn 0 */
  /* USER CODE BEGIN SVCall_IRQn 1 */

  /* USER CODE END SVCall_IRQn 1 */
}

/**
* @brief This function handles Debug monitor.
*/
void DebugMon_Handler(void)
{
  /* USER CODE BEGIN DebugMonitor_IRQn 0 */

  /* USER CODE END DebugMonitor_IRQn 0 */
  /* USER CODE BEGIN DebugMonitor_IRQn 1 */

  /* USER CODE END DebugMonitor_IRQn 1 */
}

/**
* @brief This function handles Pendable request for system service.
*/
void PendSV_Handler(void)
{
  /* USER CODE BEGIN PendSV_IRQn 0 */

  /* USER CODE END PendSV_IRQn 0 */
  /* USER CODE BEGIN PendSV_IRQn 1 */

  /* USER CODE END PendSV_IRQn 1 */
}

/**
* @brief This function handles System tick timer.
*/
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */

  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  HAL_SYSTICK_IRQHandler();
  /* USER CODE BEGIN SysTick_IRQn 1 */

  /* USER CODE END SysTick_IRQn 1 */
}

/******************************************************************************/
/* STM32F4xx Peripheral Interrupt Handlers                                    */
/* Add here the Interrupt Handlers for the used peripherals.                  */
/* For the available peripheral interrupt handler names,                      */
/* please refer to the startup file (startup_stm32f4xx.s).                    */
/******************************************************************************/

/**
* @brief This function handles DMA1 stream3 global interrupt.
*/

/**
* @brief This function handles SPI2 global interrupt.
*/
//
/**
* @brief This function handles DMA2 stream0 global interrupt.
*/

/**
* @brief This function handles DMA2 stream2 global interrupt.
*/

/**
* @brief This function handles USB On The Go FS global interrupt.
*/

/* USER CODE BEGIN 1 */
/**
* @brief This function handles TIM2 global interrupt.
*/
/*

*/
void ADC_IRQHandler(void)
{
  /* USER CODE BEGIN ADC_IRQn 0 */

  /* USER CODE END ADC_IRQn 0 */
	__HAL_ADC_CLEAR_FLAG(&hadc1, ADC_FLAG_STRT | ADC_FLAG_EOC);
	//
	my_data = (hadc1.Instance->DR)-2048;
	//
	sin_lo_mix_buf[0]=sin_lo_mix_buf[1];
	sin_lo_mix_buf[1]=sin_lo_mix_buf[2];
	sin_lo_mix_buf[2]=sin_lo_mix_buf[3];
	sin_lo_mix_buf[3]=sin_lo_mix_buf[4];
	sin_lo_mix_buf[4]=sin_lo_mix_buf[5];
	sin_lo_mix_buf[5]=sin_lo_mix_buf[6];
	sin_lo_mix_buf[6]=sin_lo_mix_buf[7];
	sin_lo_mix_buf[7]=sin_lo_mix_buf[8];
	sin_lo_mix_buf[8]=sin_lo_mix_buf[9];
	sin_lo_mix_buf[9]=sin_lo_mix_buf[10];
	sin_lo_mix_buf[10]=sin_lo_mix_buf[11];
	//
	cos_lo_mix_buf[0]=cos_lo_mix_buf[1];
	cos_lo_mix_buf[1]=cos_lo_mix_buf[2];
	cos_lo_mix_buf[2]=cos_lo_mix_buf[3];
	cos_lo_mix_buf[3]=cos_lo_mix_buf[4];
	cos_lo_mix_buf[4]=cos_lo_mix_buf[5];
	cos_lo_mix_buf[5]=cos_lo_mix_buf[6];
	cos_lo_mix_buf[6]=cos_lo_mix_buf[7];
	cos_lo_mix_buf[7]=cos_lo_mix_buf[8];
	cos_lo_mix_buf[8]=cos_lo_mix_buf[9];
	cos_lo_mix_buf[9]=cos_lo_mix_buf[10];
	cos_lo_mix_buf[10]=cos_lo_mix_buf[11];
	//
	sin_lo_mix_LPF_2_buf[0]=sin_lo_mix_LPF_2_buf[1];
	cos_lo_mix_LPF_2_buf[0]=cos_lo_mix_LPF_2_buf[1];
	//
	mix_i++;// 
	sin_lo_mix_buf[11] =( (int_fast32_t)my_data*(int_fast32_t)sin_lo_buf[mix_i&0x1fff])/2048;
	cos_lo_mix_buf[11] =( (int_fast32_t)my_data*(int_fast32_t)cos_lo_buf[mix_i&0x1fff])/2048;
	//
	sin_lo_mix_LPF_2_buf[1] = ((-11*sin_lo_mix_buf[11])-(41*sin_lo_mix_buf[10])-(55*sin_lo_mix_buf[9])+(20*sin_lo_mix_buf[8])+(200*sin_lo_mix_buf[7])+(353*sin_lo_mix_buf[6])+(353*sin_lo_mix_buf[5])+(200*sin_lo_mix_buf[4])+(20*sin_lo_mix_buf[3])-(55*sin_lo_mix_buf[2])-(41*sin_lo_mix_buf[1])-(11*sin_lo_mix_buf[0]))/1000;
	cos_lo_mix_LPF_2_buf[1] = ((-11*cos_lo_mix_buf[11])-(41*cos_lo_mix_buf[10])-(55*cos_lo_mix_buf[9])+(20*cos_lo_mix_buf[8])+(200*cos_lo_mix_buf[7])+(353*cos_lo_mix_buf[6])+(353*cos_lo_mix_buf[5])+(200*cos_lo_mix_buf[4])+(20*cos_lo_mix_buf[3])-(55*cos_lo_mix_buf[2])-(41*cos_lo_mix_buf[1])-(11*cos_lo_mix_buf[0]))/1000;
	//
	sin_lo_mix_LPF_diff = sin_lo_mix_LPF_2_buf[1]-sin_lo_mix_LPF_2_buf[0];
	cos_lo_mix_LPF_diff = cos_lo_mix_LPF_2_buf[1]-cos_lo_mix_LPF_2_buf[0];
	//  
	sin_lo_mix_LPF_diff= sin_lo_mix_LPF_diff*cos_lo_mix_LPF_2_buf[1];
	cos_lo_mix_LPF_diff= cos_lo_mix_LPF_diff*sin_lo_mix_LPF_2_buf[1];
	cos_lo_mix_LPF_diff = cos_lo_mix_LPF_diff-sin_lo_mix_LPF_diff;
	//
	cos_lo_mix_LPF_diff=(2048*cos_lo_mix_LPF_diff)/(sin_lo_mix_LPF_2_buf[1]*sin_lo_mix_LPF_2_buf[1]+cos_lo_mix_LPF_2_buf[1]*cos_lo_mix_LPF_2_buf[1]);
	//   
	HAL_DAC_SetValue(&hdac, DAC_CHANNEL_1, DAC_ALIGN_12B_R, cos_lo_mix_LPF_diff+2048);
}
/* USER CODE END 1 */
/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
